System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, GameConst, _crd, ITEM_TYPE, BOX_TYPE, ITEM_HINT_LV, ITEM_FROZEN_LV, ITEM_MAGENT_LV, ITEM_TIME_LV;

  _export({
    default: void 0,
    ITEM_TYPE: void 0,
    BOX_TYPE: void 0
  });

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "e35acRUB8JEcok+Iaxv1zHa", "GameConst", undefined);

      (function (ITEM_TYPE) {
        ITEM_TYPE["Star"] = "Star";
        ITEM_TYPE["Coin"] = "Coin";
        ITEM_TYPE["Magnet"] = "Magnet";
        ITEM_TYPE["Hint"] = "Hint";
        ITEM_TYPE["Frozen"] = "Frozen";
        ITEM_TYPE["Time"] = "Time";
      })(ITEM_TYPE || _export("ITEM_TYPE", ITEM_TYPE = {}));

      (function (BOX_TYPE) {
        BOX_TYPE[BOX_TYPE["LEVEL"] = 0] = "LEVEL";
        BOX_TYPE[BOX_TYPE["STAR"] = 1] = "STAR";
        BOX_TYPE[BOX_TYPE["TEAM"] = 2] = "TEAM";
      })(BOX_TYPE || _export("BOX_TYPE", BOX_TYPE = {}));

      _export("default", GameConst = class GameConst {
        static getLvBoxReward(key) {
          if (key == 1) {
            return [{
              type: ITEM_TYPE.Coin,
              num: 17
            }, {
              type: ITEM_TYPE.Hint,
              num: 2
            }];
          } else if (key == 2) {
            return [{
              type: ITEM_TYPE.Coin,
              num: 20
            }, {
              type: ITEM_TYPE.Hint,
              num: 3
            }, {
              type: ITEM_TYPE.Magnet,
              num: 3
            }];
          } else {
            return [{
              type: ITEM_TYPE.Coin,
              num: 30
            }, {
              type: ITEM_TYPE.Hint,
              num: 5
            }, {
              type: ITEM_TYPE.Magnet,
              num: 5
            }, {
              type: ITEM_TYPE.Time,
              num: 5
            }];
          }
        }

        static getStarBoxReward(key) {
          if (key == 1) {
            return [{
              type: ITEM_TYPE.Coin,
              num: 100
            }, {
              type: ITEM_TYPE.Hint,
              num: 5
            }];
          } else if (key == 2) {
            return [{
              type: ITEM_TYPE.Coin,
              num: 150
            }, {
              type: ITEM_TYPE.Hint,
              num: 5
            }, {
              type: ITEM_TYPE.Magnet,
              num: 5
            }];
          } else {
            return [{
              type: ITEM_TYPE.Coin,
              num: 200
            }, {
              type: ITEM_TYPE.Hint,
              num: 5
            }, {
              type: ITEM_TYPE.Magnet,
              num: 5
            }, {
              type: ITEM_TYPE.Time,
              num: 5
            }];
          }
        }

        static getItemName(type) {
          return {
            "Star": "星星",
            "Coin": "金币",
            "Magnet": "磁铁",
            "Hint": "提示",
            "Frozen": "冰冻",
            "Time": "额外时间"
          }[type];
        } //分钟


      });

      GameConst.CLEAR_ALL_BOX = "CLEAR_ALL_BOX";
      GameConst.USE_ITEM_HINT = "USE_ITEM_HINT";
      GameConst.USE_ITEM_FROZEN = "USE_ITEM_FROZEN";
      GameConst.USE_ITEM_TIME = "USE_ITEM_TIME";
      GameConst.local_data_key = "111";
      GameConst.WIN_LAYER = {
        SCENE: 10,
        POPUP: 20,
        GUIDE: 30,
        TIP: 40,
        ERROR: 50,
        VIDEO: 60
      };
      GameConst.WIN_TYPE = {
        NORMAL: 1,
        //普通
        FULLSCREEN: 2,
        //全屏
        PERMANENT: 3 //常驻

      };
      GameConst.MAX_LIFE = 5;
      GameConst.MAX_LIFE_RECOVERY_TIME = 2;

      _export("ITEM_HINT_LV", ITEM_HINT_LV = 5); //  提示


      _export("ITEM_FROZEN_LV", ITEM_FROZEN_LV = 10); //    冰冻时间
      //


      _export("ITEM_MAGENT_LV", ITEM_MAGENT_LV = 10); //    磁铁


      _export("ITEM_TIME_LV", ITEM_TIME_LV = 20); //    额外时间


      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=57b6c6ae4cbe761fa4bd7ebb556d62a302897e21.js.map